/*
 * File: gestion_reservoir.c
 *
 * Code generated for Simulink model 'gestion_reservoir'.
 *
 * Model version                  : 1.45
 * Simulink Coder version         : 8.1 (R2011b) 08-Jul-2011
 * TLC version                    : 8.1 (Aug  6 2011)
 * C/C++ source code generated on : Sat Oct 19 13:04:10 2013
 *
 * Target selection: ert_shrlib.tlc
 * Embedded hardware selection: 32-bit Generic
 * Emulation hardware selection:
 *    Differs from embedded hardware (Generic->16-bit Embedded Processor)
 * Code generation objectives: Unspecified
 * Validation result: Not run
 */

#include "gestion_reservoir.h"
#include "gestion_reservoir_private.h"

/* Block signals (auto storage) */
BlockIO_gestion_reservoir_T gestion_reservoir_B;

/* Continuous states */
ContinuousStates_gestion_rese_T gestion_reservoir_X;

/* Block states (auto storage) */
D_Work_gestion_reservoir_T gestion_reservoir_DWork;

/* External inputs (root inport signals with auto storage) */
ExternalInputs_gestion_reserv_T gestion_reservoir_U;

/* External outputs (root outports fed by signals with auto storage) */
ExternalOutputs_gestion_reser_T gestion_reservoir_Y;

/* Real-time model */
RT_MODEL_gestion_reservoir_T gestion_reservoir_M_;
RT_MODEL_gestion_reservoir_T *const gestion_reservoir_M = &gestion_reservoir_M_;

/*
 * This function updates continuous states using the ODE1 fixed-step
 * solver algorithm
 */
static void rt_ertODEUpdateContinuousStates(RTWSolverInfo *si )
{
  time_T tnew = rtsiGetSolverStopTime(si);
  time_T h = rtsiGetStepSize(si);
  real_T *x = rtsiGetContStates(si);
  ODE1_IntgData *id = (ODE1_IntgData *)rtsiGetSolverData(si);
  real_T *f0 = id->f[0];
  int_T i;
  int_T nXc = 1;
  rtsiSetSimTimeStep(si,MINOR_TIME_STEP);
  rtsiSetdX(si, f0);
  gestion_reservoir_derivatives();
  rtsiSetT(si, tnew);
  for (i = 0; i < nXc; i++) {
    *x += h * f0[i];
    x++;
  }

  rtsiSetSimTimeStep(si,MAJOR_TIME_STEP);
}

/*
 * Output and update for atomic system:
 *    '<S1>/controleur_debit'
 *    '<S1>/controleur_niveau'
 */
void gestion_reserv_controleur_debit(real_T rtu_e,
  rtB_controleur_debit_gestion__T *localB, rtDW_controleur_debit_gestion_T
  *localDW, real_T rtp_Ki, real_T rtp_Kp)
{
  real_T rtb_yi;
  real_T u;

  /* Sum: '<S4>/Add' incorporates:
   *  Gain: '<S4>/Ki'
   *  Gain: '<S4>/Ts'
   *  UnitDelay: '<S4>/Unit Delay'
   */
  u = rtp_Ki * rtu_e * 0.1 + localDW->UnitDelay_DSTATE;

  /* Saturate: '<S4>/Saturation' */
  rtb_yi = u >= 1.0 ? 1.0 : u <= -1.0 ? -1.0 : u;

  /* Sum: '<S4>/Add1' incorporates:
   *  Gain: '<S4>/Kp'
   */
  u = rtp_Kp * rtu_e + rtb_yi;

  /* Saturate: '<S4>/Saturation1' */
  localB->Saturation1 = u >= 1.0 ? 1.0 : u <= 0.0 ? 0.0 : u;

  /* Update for UnitDelay: '<S4>/Unit Delay' */
  localDW->UnitDelay_DSTATE = rtb_yi;
}

/* Model step function */
void gestion_reservoir_step(void)
{
  /* local block i/o variables */
  real_T rtb_Add;
  real_T rtb_Add1;
  real_T rtb_RateLimiter;
  if (rtmIsMajorTimeStep(gestion_reservoir_M)) {
    /* set solver stop time */
    rtsiSetSolverStopTime(&gestion_reservoir_M->solverInfo,
                          ((gestion_reservoir_M->Timing.clockTick0+1)*
      gestion_reservoir_M->Timing.stepSize0));
  }                                    /* end MajorTimeStep */

  /* Update absolute time of base rate at minor time step */
  if (rtmIsMinorTimeStep(gestion_reservoir_M)) {
    gestion_reservoir_M->Timing.t[0] = rtsiGetT(&gestion_reservoir_M->solverInfo);
  }

  /* Product: '<S2>/Product1' incorporates:
   *  Constant: '<S2>/surface_reservoir_m2'
   *  Integrator: '<S2>/Integrator'
   */
  gestion_reservoir_B.h = gestion_reservoir_X.Integrator_CSTATE /
    gestion_reservoir_P.surface_reservoir;

  /* Outport: '<Root>/niveau_courant' */
  gestion_reservoir_Y.niveau_courant = gestion_reservoir_B.h;
  if (rtmIsMajorTimeStep(gestion_reservoir_M)) {
    /* Sum: '<S1>/Add' incorporates:
     *  Inport: '<Root>/debit_cible'
     *  UnitDelay: '<S3>/Unit Delay'
     */
    rtb_Add = gestion_reservoir_U.debit_cible -
      gestion_reservoir_DWork.UnitDelay_DSTATE;

    /* Outputs for Atomic SubSystem: '<S1>/controleur_debit' */
    gestion_reserv_controleur_debit(rtb_Add,
      &gestion_reservoir_B.controleur_debit,
      &gestion_reservoir_DWork.controleur_debit, gestion_reservoir_P.Ki_debit,
      gestion_reservoir_P.Kp_debit);

    /* End of Outputs for SubSystem: '<S1>/controleur_debit' */

    /* RateLimiter: '<S2>/Rate Limiter1' */
    rtb_RateLimiter = gestion_reservoir_B.controleur_debit.Saturation1 -
      gestion_reservoir_DWork.PrevY;
    if (rtb_RateLimiter > 0.010000000000000002) {
      gestion_reservoir_B.RateLimiter1 = gestion_reservoir_DWork.PrevY +
        0.010000000000000002;
    } else if (rtb_RateLimiter < -0.010000000000000002) {
      gestion_reservoir_B.RateLimiter1 = gestion_reservoir_DWork.PrevY +
        -0.010000000000000002;
    } else {
      gestion_reservoir_B.RateLimiter1 =
        gestion_reservoir_B.controleur_debit.Saturation1;
    }

    gestion_reservoir_DWork.PrevY = gestion_reservoir_B.RateLimiter1;

    /* End of RateLimiter: '<S2>/Rate Limiter1' */
  }

  /* MATLAB Function: '<S7>/debit_entree' incorporates:
   *  Bias: '<S2>/Bias'
   *  Gain: '<S2>/g'
   *  Gain: '<S2>/rho'
   */
  /* MATLAB Function 'reservoir/debit_sortie/debit_entree': '<S9>:1' */
  /*  Relation entre le dbit et la pression: */
  /*   */
  /*  Q = 2.(Cd/sqrt(Re))^2 .S.sqrt(4.S/\pi)/(v.\rho).p */
  /*   */
  /*  avec */
  /*  Cd = Coefficient de dcharge */
  /*  Re = Coefficient de Reynolds */
  /*  v = Viscosit cinmatique du fluide */
  /*  \rho = Densit du fluide */
  /*   */
  /*  et */
  /*  p = Diffrence de pression (p_{in} - p_{out}) */
  /*  S = Section */
  /*  Q = Dbit */
  /*  Calcul de la diffrence de pression */
  /* '<S9>:1:19' */
  /*  Calcul du dbit */
  /* '<S9>:1:22' */
  gestion_reservoir_B.Q = sqrt(4.0 * gestion_reservoir_P.section_sortie /
    3.1415926535897931) * (0.081666666666666679 *
    gestion_reservoir_P.section_sortie) / (2.0 * gestion_reservoir_P.rho) *
    ((gestion_reservoir_P.rho * gestion_reservoir_B.h * gestion_reservoir_P.g +
      100000.0) - 100000.0) * gestion_reservoir_B.RateLimiter1;

  /* Outport: '<Root>/debit_courant' */
  gestion_reservoir_Y.debit_courant = gestion_reservoir_B.Q;
  if (rtmIsMajorTimeStep(gestion_reservoir_M)) {
    /* Sum: '<S1>/Add1' incorporates:
     *  Inport: '<Root>/niveau_cible'
     *  UnitDelay: '<S3>/Unit Delay1'
     */
    rtb_Add1 = gestion_reservoir_U.niveau_cible -
      gestion_reservoir_DWork.UnitDelay1_DSTATE;

    /* Outputs for Atomic SubSystem: '<S1>/controleur_niveau' */
    gestion_reserv_controleur_debit(rtb_Add1,
      &gestion_reservoir_B.controleur_niveau,
      &gestion_reservoir_DWork.controleur_niveau, gestion_reservoir_P.Ki_niveau,
      gestion_reservoir_P.Kp_niveau);

    /* End of Outputs for SubSystem: '<S1>/controleur_niveau' */

    /* RateLimiter: '<S2>/Rate Limiter' */
    rtb_RateLimiter = gestion_reservoir_B.controleur_niveau.Saturation1 -
      gestion_reservoir_DWork.PrevY_g;
    if (rtb_RateLimiter > 0.010000000000000002) {
      rtb_RateLimiter = gestion_reservoir_DWork.PrevY_g + 0.010000000000000002;
    } else if (rtb_RateLimiter < -0.010000000000000002) {
      rtb_RateLimiter = gestion_reservoir_DWork.PrevY_g + -0.010000000000000002;
    } else {
      rtb_RateLimiter = gestion_reservoir_B.controleur_niveau.Saturation1;
    }

    gestion_reservoir_DWork.PrevY_g = rtb_RateLimiter;

    /* End of RateLimiter: '<S2>/Rate Limiter' */

    /* MATLAB Function: '<S6>/debit_entree' incorporates:
     *  Constant: '<S2>/pression_entree_mps'
     */
    /* MATLAB Function 'reservoir/debit_entree/debit_entree': '<S8>:1' */
    /*  Relation entre le dbit et la pression: */
    /*   */
    /*  Q = 2.(Cd/sqrt(Re))^2 .S.sqrt(4.S/\pi)/(v.\rho).p */
    /*   */
    /*  avec */
    /*  Cd = Coefficient de dcharge */
    /*  Re = Coefficient de Reynolds */
    /*  v = Viscosit cinmatique du fluide */
    /*  \rho = Densit du fluide */
    /*   */
    /*  et */
    /*  p = Diffrence de pression (p_{in} - p_{out}) */
    /*  S = Section */
    /*  Q = Dbit */
    /*  Calcul de la diffrence de pression */
    /* '<S8>:1:19' */
    /*  Calcul du dbit */
    /* '<S8>:1:22' */
    gestion_reservoir_B.Q_m = sqrt(4.0 * gestion_reservoir_P.section_entree /
      3.1415926535897931) * (0.081666666666666679 *
      gestion_reservoir_P.section_entree) / (2.0 * gestion_reservoir_P.rho) *
      (gestion_reservoir_P.pression_entree - 100000.0) * rtb_RateLimiter;
  }

  /* Sum: '<S2>/Add' */
  gestion_reservoir_B.delta_debit = gestion_reservoir_B.Q_m -
    gestion_reservoir_B.Q;
  if (rtmIsMajorTimeStep(gestion_reservoir_M)) {
    if (rtmIsMajorTimeStep(gestion_reservoir_M)) {
      /* Update for UnitDelay: '<S3>/Unit Delay' */
      gestion_reservoir_DWork.UnitDelay_DSTATE = gestion_reservoir_B.Q;

      /* Update for UnitDelay: '<S3>/Unit Delay1' */
      gestion_reservoir_DWork.UnitDelay1_DSTATE = gestion_reservoir_B.h;
    }
  }                                    /* end MajorTimeStep */

  if (rtmIsMajorTimeStep(gestion_reservoir_M)) {
    rt_ertODEUpdateContinuousStates(&gestion_reservoir_M->solverInfo);

    /* Update absolute time for base rate */
    /* The "clockTick0" counts the number of times the code of this task has
     * been executed. The absolute time is the multiplication of "clockTick0"
     * and "Timing.stepSize0". Size of "clockTick0" ensures timer will not
     * overflow during the application lifespan selected.
     */
    ++gestion_reservoir_M->Timing.clockTick0;
    gestion_reservoir_M->Timing.t[0] = rtsiGetSolverStopTime
      (&gestion_reservoir_M->solverInfo);

    {
      /* Update absolute timer for sample time: [0.1s, 0.0s] */
      /* The "clockTick1" counts the number of times the code of this task has
       * been executed. The resolution of this integer timer is 0.1, which is the step size
       * of the task. Size of "clockTick1" ensures timer will not overflow during the
       * application lifespan selected.
       */
      gestion_reservoir_M->Timing.clockTick1++;
    }
  }                                    /* end MajorTimeStep */
}

/* Derivatives for root system: '<Root>' */
void gestion_reservoir_derivatives(void)
{
  /* Derivatives for Integrator: '<S2>/Integrator' */
  ((StateDerivatives_gestion_rese_T *) gestion_reservoir_M->ModelData.derivs)
    ->Integrator_CSTATE = gestion_reservoir_B.delta_debit;
}

/* Model initialize function */
void gestion_reservoir_initialize(boolean_T firstTime)
{
  (void)firstTime;

  /* Registration code */

  /* initialize non-finites */
  rt_InitInfAndNaN(sizeof(real_T));

  /* initialize real-time model */
  (void) memset((void *)gestion_reservoir_M, 0,
                sizeof(RT_MODEL_gestion_reservoir_T));

  {
    /* Setup solver object */
    rtsiSetSimTimeStepPtr(&gestion_reservoir_M->solverInfo,
                          &gestion_reservoir_M->Timing.simTimeStep);
    rtsiSetTPtr(&gestion_reservoir_M->solverInfo, &rtmGetTPtr
                (gestion_reservoir_M));
    rtsiSetStepSizePtr(&gestion_reservoir_M->solverInfo,
                       &gestion_reservoir_M->Timing.stepSize0);
    rtsiSetdXPtr(&gestion_reservoir_M->solverInfo,
                 &gestion_reservoir_M->ModelData.derivs);
    rtsiSetContStatesPtr(&gestion_reservoir_M->solverInfo,
                         &gestion_reservoir_M->ModelData.contStates);
    rtsiSetNumContStatesPtr(&gestion_reservoir_M->solverInfo,
      &gestion_reservoir_M->Sizes.numContStates);
    rtsiSetErrorStatusPtr(&gestion_reservoir_M->solverInfo, ((const char_T **)
      (&rtmGetErrorStatus(gestion_reservoir_M))));
    rtsiSetRTModelPtr(&gestion_reservoir_M->solverInfo, gestion_reservoir_M);
  }

  rtsiSetSimTimeStep(&gestion_reservoir_M->solverInfo, MAJOR_TIME_STEP);
  gestion_reservoir_M->ModelData.intgData.f[0] =
    gestion_reservoir_M->ModelData.odeF[0];
  gestion_reservoir_M->ModelData.contStates = ((real_T *) &gestion_reservoir_X);
  rtsiSetSolverData(&gestion_reservoir_M->solverInfo, (void *)
                    &gestion_reservoir_M->ModelData.intgData);
  rtsiSetSolverName(&gestion_reservoir_M->solverInfo,"ode1");
  rtmSetTPtr(gestion_reservoir_M, &gestion_reservoir_M->Timing.tArray[0]);
  gestion_reservoir_M->Timing.stepSize0 = 0.1;

  /* block I/O */
  (void) memset(((void *) &gestion_reservoir_B), 0,
                sizeof(BlockIO_gestion_reservoir_T));

  /* states (continuous) */
  {
    (void) memset((void *)&gestion_reservoir_X, 0,
                  sizeof(ContinuousStates_gestion_rese_T));
  }

  /* states (dwork) */
  (void) memset((void *)&gestion_reservoir_DWork, 0,
                sizeof(D_Work_gestion_reservoir_T));

  /* external inputs */
  (void) memset((void *)&gestion_reservoir_U, 0,
                sizeof(ExternalInputs_gestion_reserv_T));

  /* external outputs */
  (void) memset((void *)&gestion_reservoir_Y, 0,
                sizeof(ExternalOutputs_gestion_reser_T));

  /* InitializeConditions for Integrator: '<S2>/Integrator' */
  gestion_reservoir_X.Integrator_CSTATE =
    gestion_reservoir_P.volume_initial_reservoir;

  /* InitializeConditions for RateLimiter: '<S2>/Rate Limiter1' */
  gestion_reservoir_DWork.PrevY = 0.0;

  /* InitializeConditions for RateLimiter: '<S2>/Rate Limiter' */
  gestion_reservoir_DWork.PrevY_g = 0.0;
}

/* Model terminate function */
void gestion_reservoir_terminate(void)
{
  /* (no terminate code required) */
}

/*
 * File trailer for generated code.
 *
 * [EOF]
 */
