/*
 * File: gestion_reservoir.h
 *
 * Code generated for Simulink model 'gestion_reservoir'.
 *
 * Model version                  : 1.45
 * Simulink Coder version         : 8.1 (R2011b) 08-Jul-2011
 * TLC version                    : 8.1 (Aug  6 2011)
 * C/C++ source code generated on : Sat Oct 19 13:04:10 2013
 *
 * Target selection: ert_shrlib.tlc
 * Embedded hardware selection: 32-bit Generic
 * Emulation hardware selection:
 *    Differs from embedded hardware (Generic->16-bit Embedded Processor)
 * Code generation objectives: Unspecified
 * Validation result: Not run
 */

#ifndef RTW_HEADER_gestion_reservoir_h_
#define RTW_HEADER_gestion_reservoir_h_
#ifndef gestion_reservoir_COMMON_INCLUDES_
# define gestion_reservoir_COMMON_INCLUDES_
#include <math.h>
#include <string.h>
#include "rtwtypes.h"
#include "rtw_continuous.h"
#include "rtw_solver.h"
#include "rtGetInf.h"
#include "rtGetNaN.h"
#include "rt_nonfinite.h"
#endif                                 /* gestion_reservoir_COMMON_INCLUDES_ */

#include "gestion_reservoir_types.h"

/* Macros for accessing real-time model data structure */
#ifndef rtmGetErrorStatus
# define rtmGetErrorStatus(rtm)        ((rtm)->errorStatus)
#endif

#ifndef rtmSetErrorStatus
# define rtmSetErrorStatus(rtm, val)   ((rtm)->errorStatus = (val))
#endif

#ifndef rtmGetStopRequested
# define rtmGetStopRequested(rtm)      ((rtm)->Timing.stopRequestedFlag)
#endif

#ifndef rtmSetStopRequested
# define rtmSetStopRequested(rtm, val) ((rtm)->Timing.stopRequestedFlag = (val))
#endif

#ifndef rtmGetStopRequestedPtr
# define rtmGetStopRequestedPtr(rtm)   (&((rtm)->Timing.stopRequestedFlag))
#endif

#ifndef rtmGetT
# define rtmGetT(rtm)                  (rtmGetTPtr((rtm))[0])
#endif

/* Block signals for system '<S1>/controleur_debit' */
typedef struct {
  real_T Saturation1;                  /* '<S4>/Saturation1' */
} rtB_controleur_debit_gestion__T;

/* Block states (auto storage) for system '<S1>/controleur_debit' */
typedef struct {
  real_T UnitDelay_DSTATE;             /* '<S4>/Unit Delay' */
} rtDW_controleur_debit_gestion_T;

/* Block signals (auto storage) */
typedef struct {
  real_T h;                            /* '<S2>/Product1' */
  real_T RateLimiter1;                 /* '<S2>/Rate Limiter1' */
  real_T delta_debit;                  /* '<S2>/Add' */
  real_T Q;                            /* '<S7>/debit_entree' */
  real_T Q_m;                          /* '<S6>/debit_entree' */
  rtB_controleur_debit_gestion__T controleur_niveau;/* '<S1>/controleur_niveau' */
  rtB_controleur_debit_gestion__T controleur_debit;/* '<S1>/controleur_debit' */
} BlockIO_gestion_reservoir_T;

/* Block states (auto storage) for system '<Root>' */
typedef struct {
  real_T UnitDelay_DSTATE;             /* '<S3>/Unit Delay' */
  real_T UnitDelay1_DSTATE;            /* '<S3>/Unit Delay1' */
  real_T PrevY;                        /* '<S2>/Rate Limiter1' */
  real_T PrevY_g;                      /* '<S2>/Rate Limiter' */
  rtDW_controleur_debit_gestion_T controleur_niveau;/* '<S1>/controleur_niveau' */
  rtDW_controleur_debit_gestion_T controleur_debit;/* '<S1>/controleur_debit' */
} D_Work_gestion_reservoir_T;

/* Continuous states (auto storage) */
typedef struct {
  real_T Integrator_CSTATE;            /* '<S2>/Integrator' */
} ContinuousStates_gestion_rese_T;

/* State derivatives (auto storage) */
typedef struct {
  real_T Integrator_CSTATE;            /* '<S2>/Integrator' */
} StateDerivatives_gestion_rese_T;

/* State disabled  */
typedef struct {
  boolean_T Integrator_CSTATE;         /* '<S2>/Integrator' */
} StateDisabled_gestion_reservo_T;

#ifndef ODE1_INTG
#define ODE1_INTG

/* ODE1 Integration Data */
typedef struct {
  real_T *f[1];                        /* derivatives */
} ODE1_IntgData;

#endif

/* External inputs (root inport signals with auto storage) */
typedef struct {
  real_T niveau_cible;                 /* '<Root>/niveau_cible' */
  real_T debit_cible;                  /* '<Root>/debit_cible' */
} ExternalInputs_gestion_reserv_T;

/* External outputs (root outports fed by signals with auto storage) */
typedef struct {
  real_T niveau_courant;               /* '<Root>/niveau_courant' */
  real_T debit_courant;                /* '<Root>/debit_courant' */
} ExternalOutputs_gestion_reser_T;

/* Parameters (auto storage) */
struct Parameters_gestion_reservoir_T_ {
  real_T Ki_debit;                     /* Variable: Ki_debit
                                        * Referenced by: '<S1>/controleur_debit'
                                        */
  real_T Ki_niveau;                    /* Variable: Ki_niveau
                                        * Referenced by: '<S1>/controleur_niveau'
                                        */
  real_T Kp_debit;                     /* Variable: Kp_debit
                                        * Referenced by: '<S1>/controleur_debit'
                                        */
  real_T Kp_niveau;                    /* Variable: Kp_niveau
                                        * Referenced by: '<S1>/controleur_niveau'
                                        */
  real_T g;                            /* Variable: g
                                        * Referenced by: '<S2>/g'
                                        */
  real_T pression_entree;              /* Variable: pression_entree
                                        * Referenced by: '<S2>/pression_entree_mps'
                                        */
  real_T rho;                          /* Variable: rho
                                        * Referenced by:
                                        *   '<S2>/rho'
                                        *   '<S6>/debit_entree'
                                        *   '<S7>/debit_entree'
                                        */
  real_T section_entree;               /* Variable: section_entree
                                        * Referenced by: '<S6>/debit_entree'
                                        */
  real_T section_sortie;               /* Variable: section_sortie
                                        * Referenced by: '<S7>/debit_entree'
                                        */
  real_T surface_reservoir;            /* Variable: surface_reservoir
                                        * Referenced by: '<S2>/surface_reservoir_m2'
                                        */
  real_T volume_initial_reservoir;     /* Variable: volume_initial_reservoir
                                        * Referenced by: '<S2>/Integrator'
                                        */
};

/* Real-time Model Data Structure */
struct RT_MODEL_gestion_reservoir_T {
  const char_T * volatile errorStatus;
  RTWSolverInfo solverInfo;

  /*
   * ModelData:
   * The following substructure contains information regarding
   * the data used in the model.
   */
  struct {
    real_T *contStates;
    real_T *derivs;
    boolean_T *contStateDisabled;
    boolean_T zCCacheNeedsReset;
    boolean_T derivCacheNeedsReset;
    boolean_T blkStateChange;
    real_T odeF[1][1];
    ODE1_IntgData intgData;
  } ModelData;

  /*
   * Sizes:
   * The following substructure contains sizes information
   * for many of the model attributes such as inputs, outputs,
   * dwork, sample times, etc.
   */
  struct {
    int_T numContStates;
    int_T numSampTimes;
  } Sizes;

  /*
   * Timing:
   * The following substructure contains information regarding
   * the timing information for the model.
   */
  struct {
    uint32_T clockTick0;
    time_T stepSize0;
    uint32_T clockTick1;
    SimTimeStep simTimeStep;
    boolean_T stopRequestedFlag;
    time_T *t;
    time_T tArray[2];
  } Timing;
};

/* Block parameters (auto storage) */
extern Parameters_gestion_reservoir_T gestion_reservoir_P;

/* Block signals (auto storage) */
extern BlockIO_gestion_reservoir_T gestion_reservoir_B;

/* Continuous states (auto storage) */
extern ContinuousStates_gestion_rese_T gestion_reservoir_X;

/* Block states (auto storage) */
extern D_Work_gestion_reservoir_T gestion_reservoir_DWork;

/* External inputs (root inport signals with auto storage) */
extern ExternalInputs_gestion_reserv_T gestion_reservoir_U;

/* External outputs (root outports fed by signals with auto storage) */
extern ExternalOutputs_gestion_reser_T gestion_reservoir_Y;

/* Model entry point functions */
extern void gestion_reservoir_initialize(boolean_T firstTime);
extern void gestion_reservoir_step(void);
extern void gestion_reservoir_terminate(void);

/* Real-time Model object */
extern struct RT_MODEL_gestion_reservoir_T *const gestion_reservoir_M;

/*-
 * The generated code includes comments that allow you to trace directly
 * back to the appropriate location in the model.  The basic format
 * is <system>/block_name, where system is the system number (uniquely
 * assigned by Simulink) and block_name is the name of the block.
 *
 * Use the MATLAB hilite_system command to trace the generated code back
 * to the model.  For example,
 *
 * hilite_system('<S3>')    - opens system 3
 * hilite_system('<S3>/Kp') - opens and selects block Kp which resides in S3
 *
 * Here is the system hierarchy for this model
 *
 * '<Root>' : 'gestion_reservoir'
 * '<S1>'   : 'gestion_reservoir/controleur'
 * '<S2>'   : 'gestion_reservoir/reservoir'
 * '<S3>'   : 'gestion_reservoir/controleur/capteurs'
 * '<S4>'   : 'gestion_reservoir/controleur/controleur_debit'
 * '<S5>'   : 'gestion_reservoir/controleur/controleur_niveau'
 * '<S6>'   : 'gestion_reservoir/reservoir/debit_entree'
 * '<S7>'   : 'gestion_reservoir/reservoir/debit_sortie'
 * '<S8>'   : 'gestion_reservoir/reservoir/debit_entree/debit_entree'
 * '<S9>'   : 'gestion_reservoir/reservoir/debit_sortie/debit_entree'
 */
#endif                                 /* RTW_HEADER_gestion_reservoir_h_ */

/*
 * File trailer for generated code.
 *
 * [EOF]
 */
